/*
 * Copyright (c) 2024 Institue of Software Chinese Academy of Sciences (ISCAS).
 *
 * This file is part of FFmpeg.
 *
 * FFmpeg is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * FFmpeg is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with FFmpeg; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 */

#include "libavutil/riscv/asm.S"

func ff_clear_block_rvv, zve64x
        vsetivli      zero, 16, e64, m8, ta, ma
        vmv.v.i       v0, 0
        vse64.v       v0, (a0)

        ret
endfunc

func ff_clear_blocks_rvv, zve64x
        vsetivli      zero, 16, e64, m8, ta, ma
        vmv.v.i       v0, 0

        .rept 5
        vse64.v       v0, (a0)
        addi          a0, a0, 128
        .endr
        vse64.v       v0, (a0)

        ret
endfunc
